<template>
  <div :style="{ backgroundColor: isFieldEdited({ node, path }) ? 'rgba(255, 255, 255, 0.5)' : '' }" v-if="!fieldsGroupOptions.hideAll">
    <h1 class="i3-page-title">{{ title }}</h1>
    <pre>{{ path }}</pre>
    <!-- <pre>{{ config }}</pre> -->

    <div v-if="fieldsGroupOptions && fieldsGroupOptions.beforeAll" v-for="(comp, index) in fieldsGroupOptions.beforeAll" :key="Math.random() + index">
      <component :is="comp" :node="node" :path="path"></component>
    </div>

    <!-- {{ fieldsConfig }} -->
    [[ MultiFields widget ]]
    <div v-for="(fieldConfig, key) in fieldsConfig" :key="key">
      <!-- <pre>{{ fieldConfig }}</pre> -->
      <!-- <pre>{{ config.reference === 'media' }}</pre> -->
      <!-- <pre>{{ fieldConfig.type === 'image' }}</pre> -->
      <items-types-form :node="node" :path="[...path, key]"></items-types-form>
    </div>

    <div v-if="fieldsGroupOptions && fieldsGroupOptions.afterAll" v-for="(comp, index) in fieldsGroupOptions.afterAll" :key="Math.random() + index">
      <component :is="comp" :node="node" :path="path"></component>
    </div>
  </div>
</template>

<script>
import _ from 'lodash'

import { EDITABLE_FIELDS_GROUP_CONFIG } from '@/components/Editable/config'

import { mapGetters } from 'vuex'

// import TextField from '@/components/Editable/Fields/Widgets/TextFieldWidgetField'

export default {
  components: {
    ItemsTypesForm: () => import('./ItemsTypesForm.vue')
    // TextField,
    // ListItemsParagraphForm: () => import('./ListItemsParagraphForm.vue'),
    // ListItemForm: () => import('./ListItemForm.vue'),
    // ItemsParagraphForm: () => import('./ItemsParagraphForm.vue'),
    // ItemsForm: () => import('./ItemsForm.vue'),
    // ItemForm: () => import('./ItemForm.vue'),
    // NewItemForm: () => import('./NewItemForm.vue'),
    // DeleteItemForm: () => import('./DeleteItemForm.vue')
  },

  props: {
    title: {
      type: String,
      required: true
    },
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: false,
      default: () => []
    },
    config: {
      type: Object,
      required: true
    }
  },

  data () {
    return {
      // defaultOptions: {
      //   beforeAll: [],
      //   beforeField: {},
      //   afterField: {},
      //   afterAll: []
      // }
      // excludeList: ['_type', 'nid']
    }
  },
  // watch: {
  //   nodeData: {
  //     handler (val) {
  //       console.log('node')
  //     },
  //     deep: true
  //   }
  // },

  computed: {
    ...mapGetters({
      isFieldEdited: 'Y3TI/isFieldEdited',
      getEditedField: 'Y3TI/getEditedField'
      // getFieldConfig: 'Y3TI/getFieldConfig'
    }),

    fieldsGroupOptions () {
      return this.getFieldsGroupOptions({ config: this.config, node: this.node, path: this.path, data: this.getEditedField({ node: this.node, path: this.path }) })
    },
    // allOptions () {
    //   return {
    //     beforeAll: _.concat(this.defaultOptions.beforeAll, this.options.beforeAll),
    //     beforeField: _.assign({}, this.defaultOptions.beforeField, this.options.beforeField),
    //     afterField: _.assign({}, this.defaultOptions.afterField, this.options.afterField),
    //     afterAll: _.concat(this.defaultOptions.afterAll, this.options.afterAll)
    //   }
    // },

    // nodeData () {
    //   return _.isEmpty(this.path) ? this.node : _.get(this.node, this.path, {})
    // },
    // config () {
    //   return this.getFieldConfig({ node: this.node, path: this.path })
    // },

    fieldsConfig () {
      return this.config.fields || {}
    }
    // nodesList () {
    //   return this.getEditableNodes(this.$route.path)
    // }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    // },

    // textfieldData () {
    //   return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    // }
  },

  methods: {
    getFieldsGroupOptions: EDITABLE_FIELDS_GROUP_CONFIG,
    // getFieldOptions: EDITABLE_FIELD_CONFIG,
    // fieldOptions (fieldConfig) {
    //   return this.getFieldOptions(this.config, fieldConfig)
    // },
    // ...mapActions({
    //   storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    // }),
    isEmpty: _.isEmpty,
    isArray: _.isArray

    // update (e) {
    //   this.storeEditableFieldData({ data: { path: this.editablePath, input: e.target.innerHTML } })
    // }
  },

  created () {
    // console.log('looooo')
  }
}
</script>

<style lang="scss" scoped>
  .paragraph {
    border: 2px solid black;
    padding: 5px;
  }
  .multi {
    padding: 10px;
    border: 2px solid white;
  }
</style>
